sized data List (A : Set) : Size -> Set 
{ nil  : [i : Size] -> List A $i
; cons : [i : Size] -> A -> List A i -> List A $i
}

-- split in CPS 
fun split : [A : Set] -> [i : Size] -> List A i -> 
  (C : Set) -> (List A i -> List A i -> C) -> C
{ split A i (nil .A (j < i)) C k = k (nil A j) (nil A j)
; split A i (cons .A (j < i) a as) C k = 
    split A j as C (\ xs ys -> k ys (cons A j a xs))
}

let Cmp : Set -> Set 1
  = \ A -> A -> A -> (C : Set) -> C -> C -> C
 
fun merge : [A : Set] -> (cmp : Cmp A) ->
  [i : Size] -> List A i ->
  [j : Size] -> List A j -> List A #
{ merge A cmp i (nil .A (k < i)) j ys = ys
; merge A cmp i xs j (nil .A (l < j)) = xs
; merge A cmp i (cons .A (k < i) a as) j (cons .A (l < j) b bs) =
    cmp a b (List A #) 
      (cons A # a (merge A cmp k as $l (cons A l b bs)))
      (cons A # b (merge A cmp i (cons A k a as) l bs))
}

fun mergesort : [A : Set] -> (cmp : Cmp A) -> [i : Size] -> List A i -> List A #
{ mergesort A cmp i (nil .A (j < i)) = nil A j
; mergesort A cmp i (cons .A (j < i) a (nil .A (k < j))) = cons A j a (nil A k)
; mergesort A cmp i (cons .A (j < i) a (cons .A (k < j) b bs)) =
    split A k bs (List A #) (\ xs ys -> merge A cmp 
      # (mergesort A cmp $k (cons A k a xs)) 
      # (mergesort A cmp $k (cons A k b ys)))
} 
